unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids, Types;

type
  TCellData = record
    ImageIndex: Integer;
  end;
  PCellData = ^TCellData;

  { TForm1 }

  TForm1 = class(TForm)
    ImageList1: TImageList;
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

type
  TMyStringGrid = class(TStringGrid);

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  r, c: Integer;
begin
  for r := 1 to StringGrid1.RowCount-1 do
    for c := 1 to StringGrid1.ColCount-1 do
    begin
      StringGrid1.Cells[c, r] := Format('C%d R%d',[c, r]);
      StringGrid1.Objects[c, r] := TObject(PtrUInt(Random(Imagelist1.Count)));
    end;
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
  aRect: TRect; aState: TGridDrawState);
var
  imgIndex: Integer;
begin
  if (gdSelected in aState) then
  begin
    StringGrid1.Canvas.Brush.Color := clHighlight;
    StringGrid1.Canvas.Font.Color := clHighlightText;
  end else
  begin
    StringGrid1.Canvas.Brush.Color := clWindow;
    StringGrid1.Canvas.Font.Color := clWindowText;
  end;
  StringGrid1.Canvas.FillRect(ARect);

  if (ACol >= 1) and (ARow >= 1) then
  begin
    imgIndex := PtrUInt(StringGrid1.Objects[ACol, ARow]);
    ImageList1.Draw(StringGrid1.Canvas, ARect.Left+varCellPadding, ARect.Top, imgIndex);
    inc(ARect.Left, ImageList1.Width + varCellPadding);
  end;
  InflateRect(ARect, -varCellpadding, -varCellPadding);
  StringGrid1.Canvas.TextRect(ARect, ARect.Left, ARect.Top, StringGrid1.Cells[ACol, ARow]);
end;

end.

